
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red

extern int BandPeriod = 10;
extern int Fast = 12;
extern int Slow = 26;
extern int Smooth = 5;
extern double StdDevNumber = 1.0;
extern bool Conservative = FALSE;
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];

int init() {
   IndicatorBuffers(5);
   SetIndexBuffer(0, g_ibuf_104);
   SetIndexBuffer(1, g_ibuf_108);
   SetIndexBuffer(2, g_ibuf_112);
   SetIndexBuffer(3, g_ibuf_116);
   SetIndexBuffer(4, g_ibuf_120);
   SetIndexLabel(0, "BBMACD");
   SetIndexLabel(1, "ZeroPositive");
   SetIndexLabel(2, "ZeroNegative");
   SetIndexLabel(3, "UpHist");
   SetIndexLabel(4, "DnHist");
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_LINE,EMPTY,1);
   SetIndexStyle(2, DRAW_LINE,EMPTY,1);
   SetIndexStyle(3, DRAW_HISTOGRAM,EMPTY,3);
   SetIndexStyle(4, DRAW_HISTOGRAM,EMPTY,3);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double l_imacd_24;
   double ld_32;
   double ld_44;
   int l_ind_counted_0 = IndicatorCounted();
   int li_4 = Bars - l_ind_counted_0;
  
   for (int l_shift_20 = li_4; l_shift_20 >= 0; l_shift_20--) {
      l_imacd_24 = iMACD(Symbol(), 0, Fast, Slow, Smooth, PRICE_CLOSE, MODE_MAIN, l_shift_20);
      g_ibuf_104[l_shift_20] = l_imacd_24;
      ld_32 = 0;
      for (int li_40 = l_shift_20 + BandPeriod - 1; li_40 >= l_shift_20; li_40--) ld_32 += g_ibuf_104[li_40];
      ld_44 = ld_32 / BandPeriod;
      if (g_ibuf_104[l_shift_20] > ld_44) {
         if (Conservative) {
            if (g_ibuf_104[l_shift_20] > 0.0) {
               g_ibuf_108[l_shift_20] = 0;
               g_ibuf_112[l_shift_20] = EMPTY_VALUE;
               if (g_ibuf_108[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_108[l_shift_20 + 1] = g_ibuf_112[l_shift_20 + 1];
            }
            if (g_ibuf_104[l_shift_20] < 0.0) {
               g_ibuf_112[l_shift_20] = 0;
               g_ibuf_108[l_shift_20] = EMPTY_VALUE;
               if (g_ibuf_112[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_112[l_shift_20 + 1] = g_ibuf_108[l_shift_20 + 1];
            }
         } else {
            g_ibuf_108[l_shift_20] = 0;
            g_ibuf_112[l_shift_20] = EMPTY_VALUE;
            if (g_ibuf_108[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_108[l_shift_20 + 1] = g_ibuf_112[l_shift_20 + 1];
         }
      } else {
         if (Conservative) {
            if (g_ibuf_104[l_shift_20] > 0.0) {
               g_ibuf_108[l_shift_20] = 0;
               g_ibuf_112[l_shift_20] = EMPTY_VALUE;
               if (g_ibuf_108[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_108[l_shift_20 + 1] = g_ibuf_112[l_shift_20 + 1];
            }
            if (g_ibuf_104[l_shift_20] < 0.0) {
               g_ibuf_112[l_shift_20] = 0;
               g_ibuf_108[l_shift_20] = EMPTY_VALUE;
               if (g_ibuf_112[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_112[l_shift_20 + 1] = g_ibuf_108[l_shift_20 + 1];
            }
         } else {
            g_ibuf_112[l_shift_20] = 0;
            g_ibuf_108[l_shift_20] = EMPTY_VALUE;
            if (g_ibuf_112[l_shift_20 + 1] == EMPTY_VALUE) g_ibuf_112[l_shift_20 + 1] = g_ibuf_108[l_shift_20 + 1];
         }
      }
      if (g_ibuf_104[l_shift_20] > g_ibuf_104[l_shift_20 + 1]) {
         g_ibuf_116[l_shift_20] = l_imacd_24 - ld_44;
         g_ibuf_120[l_shift_20] = EMPTY_VALUE;
      } else {
         g_ibuf_120[l_shift_20] = l_imacd_24 - ld_44;
         g_ibuf_116[l_shift_20] = EMPTY_VALUE;
      }
   }
   return (0);
}